<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");

class EditPackageAddon extends MB_Action
{
	public $params = array("packageID", "packageAddonID");

	public function execute()
	{
		parent::execute();

		$this->smartyVars["types"] = getTypes("products");

		$packageAddon = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageAddonID" => (int)$_REQUEST["packageAddonID"],
					"packageAddonActive" => 1,
				),
			),
		)));

		$allPackageAddons = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"packageAddonActive" => 1,
				),
			),
		)));
		$packageAddons = array();
		foreach ((array)$allPackageAddons as $addon){
			$packageAddons[$addon["packageAddonProductID"]] = $addon;
		}


		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));
		$subscription = Factory()->Subscription($this->smartyVars["packageInfo"]["packageID"]);
		$this->smartyVars["packageInfo"]["canTransfer"] = $subscription->canTransfer();
		$this->smartyVars["packageInfo"]["canUpgrade"] = $subscription->canUpgrade();
		$this->smartyVars["packageInfo"]["canDowngrade"] = $subscription->canDowngrade();

		dbg("got package info");

		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetProducts</command>
				<params>
					<parentProductID>".$this->smartyVars["packageInfo"]["productID"]."</parentProductID>
					<getProductAttributeData>1</getProductAttributeData>
					<getCouponData>1</getCouponData>
					<getAllOrderFormItemData>1</getAllOrderFormItemData>
					<getOrderFormItemData>1</getOrderFormItemData>
					<getOrderFormData>1</getOrderFormData>
					<getProductVariantData>1</getProductVariantData>
					<getProductVariantPriceData>1</getProductVariantPriceData>
					<getTLDData>1</getTLDData>
					<getCycleData>1</getCycleData>
				</params>
			</mbapi>", 1)));

		foreach ((array)$productsInfo as $k => $addon){
			if ($packageAddon["packageAddonProductID"] == $addon["productID"]){
				$addonGroupID = $addon["productAddonGroupID"];
			}
		}

		$this->smartyVars["addonGroups"] = array($addonGroupID => correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"productAddonGroupID" => $addonGroupID,
				),
			),
		))));


		foreach ((array)$productsInfo as $k=>$v){
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					if ($price["currencyID"] == $this->smartyVars["packageInfo"]["currencyID"] && $price["cycleID"] == $this->smartyVars["packageInfo"]["cycleID"]){
						$prices[$price["productVariantPriceType"]] = $price["productVariantPriceAmount"];
					}
				}
			} else {
				dbg("variant price not set");
			}
			$prices["general"] = $prices[0];
			$prices["setup"] = $prices[1];
			$prices["coupon"] = $prices["general"];
			$prices["couponcycles"] = 0;
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
			} else {
			 	unset($productsInfo[$k]);
			}
		}

		foreach ((array)$productsInfo as $k => $addon){
			if ($packageAddons[$addon["productID"]]["packageID"]){
				$productsInfo[$k]["prices"]["general"] = $packageAddons[$addon["productID"]]["packageAddonPrice"];
				$productsInfo[$k]["prices"]["setup"] = $packageAddons[$addon["productID"]]["packageAddonSetup"];
				$productsInfo[$k]["prices"]["coupon"] = $packageAddons[$addon["productID"]]["couponPrice"];
				$productsInfo[$k]["prices"]["couponcycles"] = $packageAddons[$addon["productID"]]["couponNumCycles"];
				$productsInfo[$k]["selected"] = 1;
				$productsInfo[$k]["packageAddonID"] = $packageAddons[$addon["productID"]]["packageAddonID"];
			}
		}


		$keyedAddons = array();
		foreach ($productsInfo as $k => $row){
		 	if ($row["productAddonGroupID"] == $addonGroupID){
				$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
			}
		}

		$this->smartyVars["products"] = $keyedAddons;

		$this->addTemplate("packages/EditPackageAddon", $this->smartyVars);
	}
}
